// Rover R13 v0.1
// Build instruction on:
// https://homofaciens.de/technics-robots-R13-construction_en.htm

$fn=100;

//Raspberry Pi mount point
raspi_m_l = 58;
raspi_m_w = 49;
raspi_m_shift_x = -15;
raspi_m_shift_y = 0;
raspi_m_d = 5;
raspi_m_screw_d = 2;
raspi_m_h = 6;
raspi_m_socket = 1;

//Stepper motor dimensions
sm_d = 28;
sm_h = 19;
sms_d = 5;
sms_h = 8;     //shaft height
sms_shift = 8;  //shaft shift from center
smb_w = 15;   //buckle width
smb_h = 4.5;     //buckle height
sm_mount_dis = 35;  //mount points distance
sm_mount_d = 4;     //mount points diameter

chassis_w = 55.5;
chassis_l = 110;
chassis_h = 40;
chassis_wall = 2;

servo_w = 20;
servo_l = 40;
servo_lt = 53;
servo_h1 = 26.67;
servo_h2 = 9.35;
servo_h = servo_h1 + servo_h2;
servo_m_d = 10.15;
servo_m_l = (servo_lt-servo_l)/2;

servo_cut_w = 41;
servo_cut_h = 21;
servo_mount_x = 50/2;
servo_mount_d = 10;
servo_mount_d2 = 48.76;
servo_axis_offset = 9.66;
front_axis_x = chassis_l/2-24;
front_axis_y = 32;
rear_axis_x = -chassis_l/2+22;
rear_axis_y = front_axis_y;

//Chassis mount holes grid parameters
ch_dis_x = 10;
ch_dis_y = 10;
ch_no_x = 5;
ch_no_y = 10;
ch_no_x2 = 5;
ch_no_y2 = 4;
ch_l = 4;
ch_w = 3.2;
ch_w2 = 5;

rear_axle_d = 4.5;




track_l = 22;
track_h = 9;
track_w = 20;
track_wall = 1.5;
track_tolerance_w = 0.6;

M3_hole = 3.4;
M3_nut_e = 6.4;
M4_hole = 4.4;


/*
// Chain test
for(i=[0:45:315]){
  rotate([0, 0, i]){
    translate([47, 0, 0]){
      cable_chain();
    }
  }
}
rotate([0, 0, 22.5]){
  for(i=[0:90:270]){
    rotate([0, 0, i]){
      translate([25, 0, 0]){
        cable_chain();
      }
    }
  }
}
rotate([0, 0, 11.25]){
  cable_chain();
}
*/

Assembled = 1;

if(Assembled == 0){
//  chassis();
//  cable_chain();
//  rear_wheel();
//  rear_wheel_mount();
//  drive_wheel();
//  camera_mount(0);
//  ir_mount();
//  power_LED_mount();
//  power_pole(0);
  translate([0, 35, 0]){
//    power_pole(1);
//    power_pole(2);
  }
//  bumper(0);
//  bumper(45);
//  pi_mount();
//  translate([0, 0, 50])stepper_motor();
//  bottom_terminal(0);
//  top_terminal();
//  electronics_mount();
  battery_mount();
  
}
else{
  chassis();
  translate([-42, front_axis_x, 13*0]){
    rotate([0, 0, 90]){
      cable_chain();
    }
  }

  translate([-32, 75.5, -150.5]){
    rotate([90, 0, 0]){
      ir_mount();
    }
  }

  translate([-38, 29.5, -95.5]){
    rotate([0, 0, 90]){
      power_LED_mount();
    }
  }
  
  translate([0, -16.5, 21.5]){
    rotate([0, 0, 90]){
      battery_mount();
    }
  }


  translate([0, chassis_l/2-6, 33.5]){
    rotate([0, 0, 180]){
      bottom_terminal(1);
    }
  }

for(i=[0:1:1]){
  mirror([i, 0, 0]){
    translate([-50, rear_axis_x, 33.5]){
      rotate([90, 0, 90]){
        rear_wheel();
      }
    }

    translate([0, 10, 35+track_h/2]){
      rotate([90, 0, 0]){
//        rear_wheel_mount();
      }
    }


    translate([-50, front_axis_x, 33.5]){
      rotate([90, 360/(8*2), 90]){
        drive_wheel();
      }
    }
  }
}

  translate([0, 83, -0]){
    rotate([0, 180, 0]){
      camera_mount(1);
    }
  }


  translate([40, 35, -75]){
    rotate([0, 90, 180]){
      power_pole(1);
    }
  }
  translate([-40, 35, -75]){
    rotate([0, 90, 180]){
      power_pole(0);
    }
  }
  
  translate([0, 35, -150]){
    rotate([0, 180, -90]){
      top_terminal();
    }
  }
  
/*  
  translate([0, 50, -56]){
    rotate([0, 90, -90]){
      power_pole_old();
    }
  }
*/
  
  translate([0, -70, 48]){
    rotate([180, 0, 90]){
      bumper(0);
    }
  }
  translate([0, 70, 48]){
    rotate([180, 0, 270]){
      bumper(0);
    }
  }

  translate([-25, 27, -15]){
    rotate([90, 0, 90]){
//      servo();
    }
  }

  translate([0, 0, 0]){
    rotate([0, 180, 90]){
      pi_mount();
    }
  }

  translate([0, -30, -45]){
    rotate([0, 0, 90]){
      electronics_mount();
    }
  }


  translate([0, 27.7, 0]){
    rotate([0, 180, 0]){
//      servo_mount(servo_visible=1);
    }
  }

  translate([0, -27.7, 0]){
    rotate([0, 180, 180]){
//      servo_mount(sm_hx=-3.2, servo_visible=1);
    }
  }

  translate([0, 70, 45]){
    rotate([0, 180, 0]){
//      magnet_mount(1);
    }
  }
}

//bridging_test();

module battery_mount(){
  bm_w1 = chassis_w - 2 * chassis_wall - 1;
  bm_w2 = 30;
  bm_l1 = 65;
  bm_l2 = 25;
  bm_wall = 2;
  bm_slit_l1 = 5;
  bm_slit_l2 = 9;
  bm_slit_h1 = M3_hole;
  bm_slit_h2 = M3_hole+4;
  bm_slit_w = bm_w1 - 10;

  
  // Base plate
  difference(){
    union(){
      translate([(bm_l1-bm_l2-bm_slit_l2)/2, 0, 0]){
        roundedRect([bm_l2-bm_slit_l2, bm_w1, bm_wall], 5);
      }
      translate([-bm_slit_l2/2, 0, 0]){
        roundedRect([bm_l1-bm_slit_l2, bm_w2, bm_wall], 5);
      }
    }
    hull(){
      translate([5-bm_l1/2-1, 0, 0]){
        cylinder(d=M3_hole, h=bm_w1, center=true);
      }
      translate([5-bm_l1/2+1, 0, 0]){
        cylinder(d=M3_hole, h=bm_w1, center=true);
      }
    }
  }
  translate([(bm_l1-bm_slit_l2)/2, 0, bm_slit_h2/2]){
    difference(){
      union(){
        cube(size=[bm_slit_l2, bm_slit_w, bm_slit_h2], center=true);
        translate([-bm_slit_l2/2, 0, 0]){
          rotate([90, 0, 0]){
            cylinder(d=bm_slit_h2, h=bm_slit_w, center=true);
          }
        }
      }
      cube(size=[bm_slit_l2*2, bm_slit_w-10, bm_slit_h2*1.1], center=true);
      translate([bm_slit_l2/2-bm_slit_l1, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=bm_w1, center=true);
        }
      }
      translate([(bm_slit_l2-bm_slit_l1)/2-0.15, 0, 0]){
        cube(size=[bm_slit_l1-0.15, bm_w1, M3_hole], center=true);
      }
      
    }
  }
  
}

module electronics_mount(){
  em_l = 70;
  em_w = 79;
  em_h = 45;
  em_wall = 2;
  
  roundedRect([em_l, em_w, em_wall], 5);
  difference(){
    union(){
      translate([0, (em_w-em_wall)/2, em_h/2]){
        cube(size=[em_l-20, em_wall, em_h], center=true);
      }
      translate([0, -(em_w-em_wall)/2, em_h/2]){
        cube(size=[em_l-20, em_wall, em_h], center=true);
      }
    }
    translate([15, 0, em_h-6]){
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=em_w*1.1, center=true);
      }
    }
    translate([-15, 0, em_h-6]){
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=em_w*1.1, center=true);
      }
    }
  }
}

module bottom_terminal(mount=0){
  bt_w = chassis_w - 2 * chassis_wall - 0.5;
  bt_l = 7;
  bt_h = 12;
  bt_cut = 20;
  msm_h = 5;
  msm_l = 15;
  msm_screw_d = bt_cut-6;
  
  // Metal sheet mount
  
  translate([0, 20-11.5*mount, msm_h/2+7*mount]){
    difference(){
      hull(){
        translate([0, -msm_l/2, 0]){
          rotate([0, 90, 0]){
            cylinder(d=msm_h, h=bt_cut-1, center=true);
          }
        }
        translate([0, msm_l/2]){
          cube(size=[bt_cut-1, 0.1, msm_h], center=true);
        }
      }
      translate([0, -msm_l/2, 0]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=bt_cut, center=true);
        }
      }
      translate([msm_screw_d/2, msm_l/2-3, 0]){
        cylinder(d=M3_hole, h=bt_cut, center=true);
      }
      translate([-msm_screw_d/2, msm_l/2-3, 0]){
        cylinder(d=M3_hole, h=bt_cut, center=true);
      }
      translate([0, msm_l/2, 2.5]){
        cube(size=[bt_cut, 14, msm_h], center=true);
      }

    }
  }
  
  // Mount block
  translate([0, 0, bt_h/2]){
    difference(){
      cube(size=[bt_w, bt_l, bt_h], center=true);
      translate([0, 0, 5]){
        cube(size=[bt_cut, bt_l*1.1, bt_h], center=true);
      }
      translate([0, 1, 3.5]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=bt_w*2, center=true);
        }
      }
      
      translate([ch_dis_x * 2, 0, -2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=bt_l*2, center=true);
          translate([0, 0, -bt_l+1.5]){
            cylinder(d=M3_nut_e, h=bt_l*2, center=true, $fn=6);
          }
        }
      }
      translate([-ch_dis_x * 2, 0, -2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=bt_l*2, center=true);
          translate([0, 0, -bt_l+1.5]){
            cylinder(d=M3_nut_e, h=bt_l*2, center=true, $fn=6);
          }
        }
      }
    }
  }
  
}





module bumper(cut=0){
  bmp_h = 10;
  bmp_h_shift = 6;
  bmp_w = 100;
  bmp_l = 13;
  bmp_wall = 3;
  bmp_gap = chassis_w-bmp_wall;
  
  enforcement_edge = 40;
  linkage=30;
  M3_d = 3.5;
  
  translate([0, 0, bmp_h/2]){
    rotate([90, 0, 0]){
      difference(){
        union(){
          if(cut>0){
            for(i=[0:1:1]){
              mirror([0, 0, i]){
                translate([0, 0, (bmp_w+cut)/4]){
                  w=(bmp_w-cut)/2;
                  cylinder(d=bmp_h*1.5, h=w, center=true);
                }
                translate([0, 0, cut/2]){
                  sphere(d=bmp_h*1.5, center=true);
                }
              }
            }
          }
          else{
            cylinder(d=bmp_h*1.5, h=bmp_w, center=true);
          }
          translate([0, 0, bmp_w/2]){
            sphere(d=bmp_h*1.5, center=true);
          }
          translate([0, 0, -bmp_w/2]){
            sphere(d=bmp_h*1.5, center=true);
          }
          translate([bmp_l/2, 0, bmp_gap/2]){
            cube(size=[bmp_l+bmp_wall, bmp_h, bmp_wall], center=true);
          }
          translate([bmp_l/2, 0, -bmp_gap/2]){
            cube(size=[bmp_l+bmp_wall, bmp_h, bmp_wall], center=true);
          }
          //rear wall with mount holes
          translate([bmp_l, bmp_h_shift/2, 0]){
            difference(){
              cube(size=[bmp_wall, bmp_h+bmp_h_shift, chassis_w], center=true);
              edge_x = (chassis_w - (ch_no_x-1) * ch_dis_x)/2;
              for(i=[0:1:ch_no_x2-1]){
                a=-chassis_w/2 + edge_x + ch_dis_x * i;
                b=0;
                translate([0, bmp_h_shift/2, a]){
                  rotate([0, 90, 0]){
                    cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  }
                }
              }


            }
          }
        }
        //cutTop/bottom of bumper cylinder
        translate([0, bmp_h, 0]){
          cube(size=[bmp_h*2, bmp_h, bmp_w*1.5], center=true);
        }
        translate([0, -bmp_h, 0]){
          cube(size=[bmp_h*2, bmp_h, bmp_w*1.5], center=true);
        }
      }
    }
  }



  
  
}
  


module drive_wheel(){
  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));
  chain_no = 8;
  radius = (chain_l/2)/sin(180/chain_no)+track_h/2;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_d = 5.0;
  hub_h = wheel_w+5;
  pin_d = 2;
  
  translate([0, 0, wheel_w/2]){
    difference(){
      union(){
        translate([0, 0, (hub_h-wheel_w)/2]){
          cylinder(d=10, h=hub_h, center=true);
        }
        edge1=7;
        edge2=4;
        wx1=0;
        wy1=wheel_w/2;
        wx2=radius-edge1;
        wy2=wheel_w/2;
        wx3=radius;
        wy3=wheel_w/2-edge2;
        wx4=wx3;
        wy4=-wy3;
        wx5=wx2;
        wy5=-wy2;
        wx6=0;
        wy6=-wy1;
        rotate_extrude($fn=chain_no){
          polygon(points=[[wx1,wy1],[wx2,wy2],[wx3,wy3],[wx4,wy4],[wx5,wy5],[wx6,wy6]]);
        }
      }
      
      for(i=[0:1:chain_no-1]){
        rotate([0, 0, 180/chain_no + 360/chain_no*i]){
          translate([radius*cos(180/chain_no)+0.1, 0, 0]){
            rotate([90, 0, 270]){
              linear_extrude(height=track_wall+0.1, scale=0.7){
                square(size=[10.5, hub_h*2], center=true);
              }
            }
          }
        }
      }
//      cylinder(d=hub_hole, h=hub_h*1.5, center=true);
      intersection(){
        cube(size=[3.0, hub_d, hub_h*2], center=true);
        cylinder(d=hub_d, h=hub_h*2, center=true);
      }
      translate([0, 0, hub_h-1]){
        cylinder(d=hub_d, h=wheel_w, center=true);
      }
      translate([0, 0, wheel_w/2+1.5]){
        rotate([0, 90, 0]){
          cylinder(d=pin_d, h=hub_d*2.1, center=true);
        }
      }
    }
  }
}

module rear_wheel_mount(){
  mount_h = 16;
  mount_h2 = 3;
  mount_d = 30;
  mount_d2=18;
  axis_d = 4;
  M4_nut_d = 8;
  M4_nut_h = 5;
  
  translate([0, 0, mount_h/2]){
    difference(){
      cylinder(d=mount_d, h=mount_h, center=true);
      cylinder(d=axis_d, h=mount_h*1.1, center=true);
      translate([0, 0, (mount_h-M4_nut_h)/2+0.1]){
        cylinder($fn=6, d=M4_nut_d, h=M4_nut_h, center=true);
      }
    }
  }
  translate([mount_d+5, 0, mount_h2/2]){
    difference(){
      cylinder(d=mount_d, h=mount_h2, center=true);
      cylinder(d=axis_d, h=mount_h*1.1, center=true);
      translate([0, mount_d/2, 0]){
        cube(size=[mount_d, mount_d-mount_d2, mount_h2*1.1], center=true);
      }
      translate([0, -mount_d/2, 0]){
        cube(size=[mount_d, mount_d-mount_d2, mount_h2*1.1], center=true);
      }
    }
  }
}

module rear_wheel(){
  chain_l = track_l-track_h;
  echo(chain_l);
  echo(sin(90));
  chain_no = 8;
//  radius = (chain_l/2)/sin(180/chain_no)+track_h/2-track_wall;
  radius = (chain_l/2)/sin(180/chain_no)+track_h/2-track_wall;
  echo(radius);
  wheel_w = track_w-2*track_wall-track_tolerance_w-1;
  hub_hole = 4.4;
  
  translate([0, 0, wheel_w/2]){
    difference(){
      edge1=7;
      edge2=4;
      wx1=0;
      wy1=wheel_w/2;
      wx2=radius-edge1;
      wy2=wheel_w/2;
      wx3=radius;
      wy3=wheel_w/2-edge2;
      wx4=wx3;
      wy4=-wy3;
      wx5=wx2;
      wy5=-wy2;
      wx6=0;
      wy6=-wy1;
      rotate_extrude($fn=200){
        polygon(points=[[wx1,wy1],[wx2,wy2],[wx3,wy3],[wx4,wy4],[wx5,wy5],[wx6,wy6]]);
      }
      //cylinder($fn=200, r=radius, h=wheel_w, center=true);
      cylinder(d=hub_hole, h=wheel_w*1.5, center=true);
    }
  }
}


module cable_chain(){
  width=track_w;
  height=track_h;
  length=track_l;
  wall=track_wall;
  tolerance=0.6;
  tolerance_w=track_tolerance_w;
  tolerance_stop = 0.4;
  overlap=0.5;
  link_w=7;
  l_stop=length/2-(link_w/2-(length/2-height))-tolerance_stop;
  
  
  l=length-height;
  
  scale_a = height/(cos(180/8)*height);
  
  x1=l/2;
  y1=0;
  x2=l/2;
  y2=height/2;
  x3=l_stop;
  y3=height/2;
  x4=l_stop;
  y4=height/3;
  
  for(i=[0:1:1]){
    mirror([0, i, 0]){
      translate([0, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          difference(){
            union(){
              translate([(l/2-overlap)/2, 0, 0]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }
              //stopper
              translate([l_stop/2, -(height)/4, 0]){
                //cube(size=[l_stop, height/2, wall], center=true);
              }
              translate([-(l/2-overlap)/2, 0, wall+tolerance_w]){
                cube(size=[l/2+overlap, height, wall], center=true);
              }            
              translate([0, -height/2, -wall/2]){
                linear_extrude(height=wall){
                  polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                }
              }
              mirror([0,1,0]){
                translate([0, -height/2, -wall/2]){
                  linear_extrude(height=wall){
                    polygon(points=[[x1,y1],[x2,y2],[x3,y3],[x4,y4]]);
                  }
                }
              }              
              translate([-l/2, 0, wall+tolerance_w]){
                scale([1, scale_a]){
                  rotate([0, 0, 360/8/2]){
                    cylinder($fn=8, d=height, h=wall, center=true);
                  }
                }
              }
              translate([l/2, 0, wall]){
                cylinder(d1=height/2, d2=height/2-wall, h=wall, center=true);
              }
            }
            translate([-l/2, 0, wall+tolerance_w]){
              cylinder(d1=height/2, d2=height/2-wall, h=wall+0.025, center=true);
            }
          }
        }
      }
    }
  }

    //Center bottom plate  
    difference(){
//      translate([0, 0, wall/2]){
//        cube(size=[link_w, width-2*wall, wall], center=true);
//      }
      linear_extrude(height=wall, scale=[0.7, 1]){
        square(size=[link_w, width-2*wall], center=true);
        
      }
      translate([-l/2, 0, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=width, center=true);
        }
      }
    }
    difference(){
      translate([-link_w/4+overlap/2, (width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, (width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
    difference(){
      translate([-link_w/4+overlap/2, -(width-wall+tolerance_w)/2, height/2]){
        cube(size=[link_w/2+overlap, wall+tolerance_w, height], center=true);      
      }
      translate([-l/2, -(width-wall)/2, height/2]){
        rotate([90, 0, 0]){
          cylinder(d=height+tolerance, h=wall*2.1, center=true);
        }
      }
    }
//  }
  
}

module top_terminal(){
  tt_l = 80;
  tt_w = 30;
  tt_h1 = 10;
  tt_h2 = 20;
  tt_d = 20;
  tt_lever = 10;
  tt_wall = 2;
  
  sphere_d = 60;
  
  translate([0, 0, tt_h1/2]){
    
    difference(){
      union(){
        hull(){
          translate([tt_l/2, 0, 0]){
            rotate([90, 0, 0]){
              cylinder(d=tt_h1, h=tt_w, center=true);
            }
          }
          translate([-tt_l/2, 0, (tt_h2-tt_h1)/2]){
            rotate([90, 0, 0]){
              cylinder(d=tt_h2, h=tt_w, center=true);
            }
          }
        }
        translate([5-tt_l/2, 0, tt_h2-sphere_d/2]){
          intersection(){
            sphere(d=sphere_d);
            translate([0, 0, sphere_d/2]){
              cylinder(d=29, h=25, center=true);
            }
          }
        }
          
      }
      // Inner cut
      hull(){
        translate([tt_l/2-tt_wall-33, 0, -2]){
          cube(size=[0.1, tt_w-2*tt_wall, tt_h1+10], center=true);
        }
        translate([tt_wall-tt_l/2, 0, (tt_h2-tt_h1)/2-2]){
          rotate([90, 0, 0]){
            cylinder(d=tt_h2, h=tt_w-2*tt_wall, center=true);
          }
        }
      }
      translate([tt_lever, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=tt_w*1.1, center=true);
        }
      }
      translate([tt_l/2, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=tt_w*1.1, center=true);
        }
      }
      // Spring mount hole
      translate([tt_l/2, 0, 0]){
        rotate([0, 0, 0]){
          cylinder(d=M3_hole, h=tt_w*1.1, center=true);
        }
      }
      
      // Sliding contact mount holes
      translate([tt_l/2-5, 0, 0]){
        rotate([0, 0, 0]){
          cylinder(d=M3_hole, h=tt_w*3.1, center=true);
        }
      }
      translate([tt_l/2-25, 0, 0]){
        rotate([0, 0, 0]){
          cylinder(d=M3_hole, h=tt_w*3.1, center=true);
        }
      }
      
    }
  }
  
}

module power_pole(servo = 1){
  pp_h = 150;
  pp_l_b = 30;
  pp_l_t = 10;
  pp_w = 80;
  pp_wall = 3;
  pp_m_d = 20;
  pp_socket_h = 55;
  pp_screw2 = 15;
  
  // Micro servo dimensions
  s_w = 12.5;
  s_h = 22;
  s_l = 22.5+12;
  s_screw_d = s_l - 6;
  

  difference(){
    hull(){
      translate([-pp_h/2, 0, pp_wall/2]){
        cube(size=[0.1, pp_l_b, pp_wall], center=true);
      }
      translate([pp_h/2, -(pp_l_b-pp_l_t)/2, pp_wall/2]){
        cylinder(d=pp_l_t, h=pp_wall, center=true);
      }
    }
    translate([pp_h/2, -(pp_l_b-pp_l_t)/2, pp_wall/2]){
      cylinder(d=M3_hole, h=pp_wall*1.1, center=true);
    }
    translate([5-pp_h/2, pp_m_d/2, 0]){
      rotate([0, 0, 0]){
        cylinder(d=M3_hole, h=pp_w*1.1, center=true);
      }
    }
    translate([5-pp_h/2, -pp_m_d/2, 0]){
      rotate([0, 0, 0]){
        cylinder(d=M3_hole, h=pp_w*1.1, center=true);
      }
    }
    translate([pp_screw2, -pp_m_d/2, 0]){
      rotate([0, 0, 0]){
        cylinder(d=M3_hole, h=pp_w*1.1, center=true);
      }
    }
  }
  
  
  if(servo==1){// Camera servo mount
    translate([-15, pp_wall/2-pp_l_b/2, s_h/2+pp_wall]){
      difference(){
        hull(){
          translate([s_l/2+1, 0, s_h/2-3]){
            rotate([90, 0, 0]){
              cylinder(d=3, h=pp_wall, center=true);
            }
          }
          translate([-s_l/2-1, 0, s_h/2-3]){
            rotate([90, 0, 0]){
              cylinder(d=3, h=pp_wall, center=true);
            }
          }
          translate([0, pp_wall*2, -s_h/2]){
            cube(size=[s_l+2, pp_wall*5, 0.1], center=true);
          }
        }
        translate([s_screw_d/2, 0, 0]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pp_wall*6.1, center=true);
          }
        }
        translate([-s_screw_d/2, 0, 0]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pp_wall*6.1, center=true);
          }
        }
        translate([s_screw_d/2, 5, 0]){
          rotate([90, 30, 0]){
            cylinder(d=M3_nut_e, h=10, center=true, $fn=6);
          }
        }
        translate([-s_screw_d/2, 5, 0]){
          rotate([90, 30, 0]){
            cylinder(d=M3_nut_e, h=10, center=true, $fn=6);
          }
        }
      }
    }
  }
  if(servo==2){
    // Rear plate
    translate([30, pp_l_b/2, 0]){
      difference(){
        rotate([0, 0, 0]){
          roundedRect([s_l, s_h/2, pp_wall], 3, [1,1,1,1]);
        }
        translate([s_screw_d/2, 0, 0]){
          rotate([0, 0, 0]){
            cylinder(d=M3_hole, h=pp_wall*2.1, center=true);
          }
        }
        translate([-s_screw_d/2, 0, 0]){
          rotate([0, 0, 0]){
            cylinder(d=M3_hole, h=pp_wall*2.1, center=true);
          }
        }
      }
    }


  }
  
    
}

  

module stepper_motor(){
  
  cylinder(d=sm_d, h=sm_h, center=true);
  translate([-sms_shift, 0, (sm_h+sms_h)/2]){
    cylinder(d=sms_d, h=sms_h, center=true);  
  }
  translate([sm_d/4+smb_h, 0, 0]){
    cube(size=[sm_d/2, smb_w, sm_h], center=true);
  } 
  translate([sm_d/4+1, 0, 0]){
    cube(size=[sm_d/2-3, smb_w+4, sm_h], center=true);
  } 
  // Mounts
  translate([0, sm_mount_dis/2, (sm_h)/2]){
    cylinder(d=sm_mount_d, h=sm_h*2, center=true);  
  }
  translate([0, -sm_mount_dis/2, (sm_h)/2]){
    cylinder(d=sm_mount_d, h=sm_h*2, center=true);  
  }

}

module servo(tolerance=0){
  translate([0, 0, servo_h/2]){
    cube(size=[servo_l, servo_w+tolerance, servo_h+tolerance], center=true);
    translate([servo_l/2-servo_axis_offset, 0, 25]){
      rotate([0, 0, 90]){
        cylinder(d=30, h=2, center=true);
      }
    }
  }
  translate([0, 0, servo_h1+1]){
    cube(size=[servo_lt, servo_w+tolerance, 3], center=true);
  }
  
}

module servo_horn(leverangle = 90, cylinder_d=15){
  horn_d = 41;
  horn_w1 = 12;
  horn_w2 = 6;
  horn_thickness = 3;
  horn_mount = 13.7;

  xh1=0;
  yh1=horn_w1/2;
  xh2=horn_d/2-horn_w2/2;
  yh2=horn_w2/2;
  xh3=horn_d/2-horn_w2/2;
  yh3=-horn_w2/2;
  xh4=0;
  yh4=-horn_w1/2;
  
  translate([0, 0, horn_thickness/2]){
    cylinder(d=cylinder_d, h=horn_thickness, center=true);
  }
  for(i=[0:leverangle:360]){
    rotate([0, 0, i]){
      translate([horn_mount, 0, 0]){
        cylinder(d=3, h=20.1, center=true);
      }
      translate([(horn_d-horn_w2)/2, 0, horn_thickness/2]){
        cylinder(d=horn_w2, h=horn_thickness, center=true);
      }
      translate([0, 0, 0]){
        linear_extrude(height=horn_thickness){
          polygon(points=[[xh1,yh1],[xh2,yh2],[xh3,yh3],[xh4,yh4]]);
        }
      }
    }
  }
}

module ir_mount(){
  ir_l = 30;
  ir_w = 25;
  ir_h = 12;
  ir_wall = 3;
  ir_depth = 10;
  ir_space = 10;
  
  diode_d1 = 5.2;
  diode_d2 = 7.2;
  
  rec_w = 6.5;
  rec_w2 = 8;
  rec_h = 10;
  rec_d = 5;
  
  
  translate([0, 0, ir_depth/2]){
    difference(){
      cube(size=[ir_w, ir_h, ir_depth], center=true);
      // Cut IR receiver
      translate([-ir_space/2, 0, 2]){
        cube(size=[rec_w, rec_h, ir_depth], center=true);
      }
      translate([-ir_space/2, rec_h/2-rec_h/6, 2]){
        cube(size=[rec_w2, rec_h/3, ir_depth], center=true);
      }
      translate([-ir_space/2, -1, 0]){
        cylinder(d=diode_d1, h=ir_depth*1.1, center=true);
      }
      // Cut IR diode
      translate([ir_space/2, 0, 0]){
        cylinder(d=diode_d1, h=ir_depth*1.1, center=true);
      }
      translate([ir_space/2, 0, 8]){
        cylinder(d=diode_d2, h=ir_depth, center=true);
      }
    }
  }
  translate([-ir_w/2, 0, ir_l/2]){
    difference(){
      union(){
        cube(size=[ir_wall, ir_h, ir_l], center=true);
        translate([0, 0, ir_l/2]){
          rotate([0, 90, 0]){
            cylinder(d=ir_h, h=ir_wall, center=true);
          }
        }
      }
      translate([0, 0, ir_l/2]){
        rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=ir_wall*1.1, center=true);
        }
      }
    }
  }
  
}

module power_LED_mount(){
  pled_l = 30;
  pled_w = 10;
  pled_wall = 3;
  LED_d = 5.2;
  
  translate([0, 0, pled_w/2]){
    difference(){
      union(){
        cube(size=[pled_l, pled_wall, pled_w], center=true);
        translate([pled_l/2, 0, 0]){
          rotate([90, 0, 0]){
            cylinder(d=pled_w, pled_wall, center=true);
          }
        }
        translate([1-LED_d/2-pled_wall-pled_l/2, 0, 0]){
          cylinder(d=LED_d+2*pled_wall, h=pled_w, center=true);
        }
      }

      translate([pled_l/2, 0, 0]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=pled_wall*1.1, center=true);
        }
      }
      translate([1-LED_d/2-pled_wall-pled_l/2, 0, 0]){
        cylinder(d=LED_d, h=pled_w*1.1, center=true);
      }
      translate([1-LED_d/2-pled_wall-pled_l/2, 0, 1]){
        cylinder(d=LED_d+2, h=pled_w, center=true);
      }

    }
    
  }
}

module camera_mount(modify=0){

  cam_w = 27;
  cam_h = 25;
  cam_l = 14;
  cam_pos = -1;
  cam_slot = 1.5;
  cam_slot_w = 2;

  cm_wall = 2;
  cm_w = cam_w + 40;
  cm_h = cam_h+cm_wall;
  lever_l = 6;
  lever_radius = 5;
  lever_z = cm_h/2-lever_radius;

  lever_l = 10;
  lever_radius = 5;
  lever_gap = 20;
  lever_z = lever_radius-cm_h/2;

  lever2_l = -1;
  lever2_radius = 5;
  lever2_z = cm_h/2-lever_radius+22;

  LED_d = 5.1;
  LED_w = cm_w - 17 - 5;
  LED_no = 3;

  mount_l = 15;
  mount_h = 10;
  mount_edge = 10;
  
  
  //Mount hinges
  for(i=[0:1:1]){
    mirror([i, 0, 0]){
      translate([15+4*modify, 20-38*modify, 5*modify]){
        rotate([90*modify, 0, 90*modify]){
          difference(){
            union(){
              translate([0, 0, cm_wall]){
                cube(size=[mount_l, mount_h, cm_wall*2], center=true);
              }
              translate([mount_l/2, 0, cm_wall]){
                cylinder(d=mount_h, h=cm_wall*2, center=true);
              }
              translate([-mount_l/2, 0, mount_edge/2]){
                cube(size=[cm_wall*2, mount_h, mount_edge], center=true);
              }
              translate([-mount_l/2, 0, mount_edge]){
                rotate([0, 90, 0]){
                  cylinder(d=mount_h, h=cm_wall*2, center=true);
                }
              }
            }
            translate([mount_l/2, 0, cm_wall/2]){
              cylinder(d=M3_hole, h=cm_wall*4.1, center=true);
            }
            translate([-mount_l/2, 0, mount_edge]){
              rotate([0, 90, 0]){
                cylinder(d=M3_hole, h=cm_wall*2.1, center=true);
              }
            }
          }
        }
      }
    }
  }


  translate([0, 0, 0]){
  
    //Camera box
    difference(){
      translate([0, 0, cm_h/2]){
        rotate([90, 0, 180]){
          difference(){
            roundedRect(size=[cm_w, cm_h, cm_wall], radius=3);
            gap = cm_h / LED_no;
            for(i=[0:1:LED_no-1]){
              translate([LED_w/2-2.5, (cm_h-gap)/2-i*gap, cm_wall/2]){
                cylinder(d=LED_d, h=cm_wall*1.1, center=true);
              }
              mirror([1, 0, 0]){
                translate([LED_w/2+2.5, (cm_h-gap)/2-i*gap, cm_wall/2]){
                  cylinder(d=LED_d, h=cm_wall*1.1, center=true);
                }
              }
            }
          }
          translate([-2.5, 0, 0]){
            roundedRect(size=[cam_w+2*cm_wall, cm_h, cam_l], radius=2);
          }
        }
      }
      // Cut camera
      translate([2.5, cam_l/2+cm_wall-2, cm_h/2+cm_wall]){
        cube(size=[cam_w-2*cam_slot_w, cam_l-4, cam_h], center=true);
      }
      translate([2.5, cam_l/2+cm_wall, cm_h/2+cm_wall+12.5]){
        cube(size=[15, cam_l, cam_h], center=true);
      }
      translate([2.5, cam_l/2+cm_wall, cm_h/2+cm_wall]){
        rotate([90, 0, 0]){
          cylinder(d=15, h=cam_l, center=true);
        }
      }
      // Cut camera slit
      translate([2.5, cam_l/2+cam_pos, cm_h/2+cm_wall]){
        cube(size=[cam_w, cam_slot, cam_h], center=true);
      }
    }
    
    
    //Lever mounts
    translate([2.5, 0, 0]){
      for(i=[0:1:1]){
        mirror([i, 0, 0]){
          translate([lever_gap/2, 0, cm_h/2]){
            rotate([0, 90, 0]){
              difference(){
                hull(){
                  translate([-lever_z, -lever_l, 0]){
                    cylinder(r=lever_radius, h=cm_wall, center=true);  
                  }
                  translate([0, cm_wall/2, 0]){
                    cube(size=[cm_h, cm_wall, cm_wall], center=true);
                  }
                }
                translate([-lever_z, -lever_l, 0]){
                  cylinder(d=M3_hole, h=cm_wall*1.1, center=true);  
                }          
              }
            }
          }
        }
      }
    }

    //Lever servo
    translate([cm_wall-cm_w/2, 0, cm_h/2+3]){
      rotate([0, 90, 0]){
        difference(){
          union(){
            hull(){
              translate([-lever2_z, -lever2_l, 0]){
                cylinder(r=lever2_radius, h=cm_wall*2, center=true);  
              }
              translate([-6.5, cm_wall/2, 0]){
                cube(size=[lever2_z+cm_h/2-5,cm_wall,cm_wall*2],center=true);
              }
            }
            hull(){
              translate([5-lever2_z, cm_wall/2, 0]){
                cube(size=[1,cm_wall,cm_wall*2],center=true);
              }
              translate([21-lever2_z,  cm_wall/2, 0]){
                cube(size=[1,cm_wall,cm_wall*2],center=true);
              }
              translate([21-lever2_z,  cm_wall/2, 20]){
                cube(size=[1,cm_wall,cm_wall*2],center=true);
              }
            }
          }
          translate([-lever2_z, -lever2_l, 0]){
            cylinder(d=M3_hole, h=cm_wall*2.1, center=true);  
          }          
        }
      }
    }
    
  }
  
}



module pi_mount(){
  pm_wall = 2;
  pm_w = 74;
  pm_l = chassis_l;
  
  pm_m_d = 54.0;
  pm_m_shift_x = 2.5;
  pm_m_shift_z = 3.5;
  
  wall_h = 10;
  mount_holes_x = 29;
  
  tower_m_d = 20;
  tower_m_x = -5;
  
  //Central cut
  cc_d = 20;
  cc_l = 25;

  
  translate([0, 0, pm_wall/2]){
    block_l = 4;
    block_w = 35;
    block_h = servo_w+5;
    block_edge = 8;

    
    difference(){
      union(){
        cube(size=[pm_l, pm_w, pm_wall], center=true);
        //Pi mount points
        translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall/2]){
          translate([raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
          translate([-raspi_m_l/2, -raspi_m_w/2, raspi_m_h/2]){
            cylinder(d=raspi_m_d, h=raspi_m_h, center=true);
          }
        }
        //Walls
        translate([pm_l/2-pm_wall, 0, raspi_m_h/2]){
          cube(size=[pm_wall*2, pm_w, raspi_m_h], center=true);
        }
        translate([pm_l/2-pm_wall, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall*2, pm_w, wall_h], center=true);
            translate([0, 0, 35]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([pm_wall-pm_l/2, 0, wall_h/2]){
          difference(){
          cube(size=[pm_wall*2, pm_w, wall_h], center=true);
            translate([0, 0, 33]){
              rotate([45, 0, 0]){
                cube(size=[pm_w, pm_w, pm_w], center=true);
              }
            }
          }
        }
        translate([0, pm_w/2-pm_wall, wall_h/2]){
          cube(size=[pm_l, pm_wall*2, wall_h], center=true);
        }
        translate([0, -pm_w/2+pm_wall, wall_h/2]){
          cube(size=[pm_l, pm_wall*2, wall_h], center=true);
        }
      }
      //Mount holes on chassis
      translate([4.5*ch_dis_y, 2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([4.5*ch_dis_y, -2*ch_dis_x, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      translate([-4.5*ch_dis_y, 0, 0]){
        cylinder(d=M3_hole, h=pm_wall*2, center=true);
      }
      //Central hole
      hull(){
        translate([cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
        translate([-cc_l/2, 0, 0]){
          cylinder(d=cc_d, h=pm_wall*2, center=true);
        }
      }
      //Mount holes power pole
      for(i=[(tower_m_d-pm_l)/2:tower_m_d/2:(pm_l-tower_m_d)/2]){
        translate([i, pm_w/2, 5]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }
        translate([i, -pm_w/2, 5]){
          rotate([90, 0, 0]){
            cylinder(d=M3_hole, h=pm_wall*2.1, center=true);
          }
        }

        translate([i, pm_w/2-pm_wall*1.5, 5]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        translate([i, -pm_w/2+pm_wall*1.5, 5]){
          rotate([90, 0, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
      }
      
      //Mount holes on chassis (camera mount)
      translate([0, 0, pm_m_shift_z+pm_wall/2]){
        translate([pm_l/2, pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=5, center=true);
          }
        }
        translate([pm_l/2, -pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=5, center=true);
          }
        }
        translate([pm_l/2-pm_wall*1.5, pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        translate([pm_l/2-pm_wall*1.5, -pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }

        translate([-pm_l/2, pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=5, center=true);
          }
        }
        translate([-pm_l/2, -pm_m_d/2-pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=5, center=true);
          }
        }
        translate([pm_wall*1.5-pm_l/2, pm_m_d/2+pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
        translate([pm_wall*1.5-pm_l/2, -pm_m_d/2-pm_m_shift_x, 0]){
          rotate([0, 90, 0]){
            cylinder(d=M3_nut_e, h=pm_wall*2, center=true, $fn=6);
          }
        }
      }

      //Pi mount holes
      translate([raspi_m_shift_x, raspi_m_shift_y, pm_wall]){
        translate([raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
        translate([-raspi_m_l/2, -raspi_m_w/2, 0]){
            cylinder(d=raspi_m_screw_d, h=raspi_m_h*2.1, center=true);
        }
      }
      
    }
    
  }
}



module chassis(){
  
  translate([0, 0, chassis_wall/2]){
    difference(){
      union(){
        cube(size=[chassis_w, chassis_l, chassis_wall], center=true);
        translate([(chassis_w-chassis_wall)/2, 0, chassis_h/2]){
          cube(size=[chassis_wall, chassis_l-2*chassis_wall, chassis_h], center=true);
        }
        translate([-(chassis_w-chassis_wall)/2, 0, chassis_h/2]){
          cube(size=[chassis_wall, chassis_l-2*chassis_wall, chassis_h], center=true);
        }
        translate([0, (chassis_l-chassis_wall)/2, chassis_h/2]){
          cube(size=[chassis_w, chassis_wall, chassis_h], center=true);
        }
        translate([0, -(chassis_l-chassis_wall)/2, chassis_h/2]){
          cube(size=[chassis_w, chassis_wall, chassis_h], center=true);
        }
      }
      
      // Stepper motor cuts
      translate([-chassis_w/2, front_axis_x, front_axis_y-sms_shift]){
        rotate([0, 90, 0]){
          stepper_motor();
        }
      }
      translate([chassis_w/2, front_axis_x, front_axis_y-sms_shift]){
        rotate([0, 90, 0]){
          stepper_motor();
        }
      }

      //Rear axis cuts
      //diff=(track_l-track_h)/2;
      diff=15;
      translate([0, rear_axis_x-diff/2, rear_axis_y]){
        rotate([90, 0, 90]){
          cylinder(d=rear_axle_d, h=chassis_w*1.1, center=true);
        }
      }
      translate([0, rear_axis_x+diff/2, rear_axis_y]){
        rotate([90, 0, 90]){
          cylinder(d=rear_axle_d, h=chassis_w*1.1, center=true);
        }
      }
      translate([0, rear_axis_x, rear_axis_y]){
        cube(size=[chassis_w*1.1, diff, rear_axle_d], center=true);
      }

      //Servo plug hole
      cylinder(d=15, h=5, center=true);
      
      //mount holes grid bottom
      for(j=[0:1:ch_no_y-1]){
        edge_x = (chassis_w - (ch_no_x-1) * ch_dis_x)/2;
        edge_y = (chassis_h - (ch_no_y-1) * ch_dis_y)/2;
        for(i=[0:1:ch_no_x-1]){
          a=-chassis_w/2 + edge_x + ch_dis_x * i;
          b=-(chassis_h+chassis_wall)/2 + edge_y + ch_dis_y * j;
          translate([a, b, 0]){
            if(!(j==5 && i==2)){
              translate([0, ch_l/2, 0]){
                cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                translate([0, 0, 0.75]){
                  cylinder(d=M3_nut_e, h=chassis_wall, center=true, $fn=6);
                }
              }
            }
          }
        }
      }

      
      //mount holes grid front and rear
      translate([0, 0, chassis_h/2]){
        rotate([90, 0, 0]){
          edge_x = (chassis_w - (ch_no_x2-1) * ch_dis_x)/2;
          edge_y = (chassis_h - (ch_no_y2-1) * ch_dis_y)/2;
          for(j=[0:1:ch_no_y2-1]){
            for(i=[0:1:ch_no_x2-1]){
              a=-chassis_w/2 + edge_x + ch_dis_x * i;
              b=-(chassis_h+chassis_wall)/2 + edge_y + ch_dis_y * j;
              translate([a, b, 0]){
                translate([0, ch_l/2, 0]){
                  cylinder(d=M3_hole, h=chassis_l*1.1, center=true);
                  cylinder(d=M3_nut_e, h=chassis_l-1.95, center=true, $fn=6);
                }
              }
            }
          }
        }
      }
      
    }
  }
       
}



module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}